/* ==========================================================
   programme: Search.java
   auteur: felipe IFT 1010
   objet: recherche dichotomique versus recherche lineaire
          methodes, tableaux
   ========================================================== */

public class Search {

  // dichotomique search
  static int dichoSearch(String table[], String cle) {
    int deb,fin,milieu;

    deb = 0;
    fin = table.length-1;

    do {
      milieu = (deb + fin) / 2;
      int comp = table[milieu].compareTo(cle);
      if (comp == 0) return milieu;
      if (comp > 0) fin = milieu - 1;
      else deb = milieu + 1;
    } while (deb <= fin);

    return -1;
  }

  // linear search
  static int lineaireSearch(String table[], String cle) {
    for (int i=0; i<table.length; i++)
      if (table[i].equalsIgnoreCase(cle)) return i;
    return -1; // pas trouve
  }

  //Main method
  public static void main(String[] args) {
     int i;
     String tab [] = {"alexa", "fabienne", "franois", "jean",
                      "johanne","lili","marlne", "nathalie",
                      "olivier", "sandra", "virginie"};

     if (args.length == 2) {

       i = (args[0].equalsIgnoreCase("linear")) ? lineaireSearch(tab,args[1]) :
                                                  dichoSearch(tab,args[1]);

       if (i == -1) System.out.println("la cle " + args[1] + " n'est pas dans la table");
       else System.out.println("la cle " + args[1] + " est dans la table  l'indice " + i);

     } else System.out.println("usage Search linear|dicho cle");

  }

}

